# A REST based API to start DBMS workloads powered by Swagger

## Overview

The API enables the execution of different DBMS workloads based on a JSON based workload templates

### Supported workloads

- YCSB

- TPC-C (CockroachDB implementation)

- TS Benchmark Suite (TBD)

- ...

  

### Additional workloads

- filebench (TBD)



## Dev Setup

#### Get source:

1. Java 1.8 required
2. Workload binaries are required to test the execution of workloads, for more details check the Dockerfile!
3. Start from source and access the dashboard at http://localhost:8181 


```bash
git clone https://omi-gitlab.e-technik.uni-ulm.de/mowgli/workload-API.git
cd workload-API
sudo mvn jetty:run
```

#### From Docker Registry:

1. provide the INFLUXDB_URL for the InfluxDB, e.g. 1.2.3.4:8086
2. provide the PUBLIC_IP of the host for using the SwaggerUI

```dockerfile
docker run -d -p 8181:8181 -e PUBLIC_IP=localhost -e INFLUXDB_URL=IP:PORT -v /tmp:/opt/results -v /tmp:/var/log omi-registry.e-technik.uni-ulm.de/mowgli/workload-api:latest
```



#### Swagger API

The API will be available at this endpoint:

```
http://localhost:8181/v1/swagger.json
```

and acces the basic  WEB dashboard via

```
http://localhost:8181/index.html
```

## Start a workload

Check the [getting started guide](https://omi-gitlab.e-technik.uni-ulm.de/mowgli/getting-started) of the Mowgli framework!

------

## Acknowledgements

The REST server was generated by the [swagger-codegen](https://github.com/swagger-api/swagger-codegen) project. By using the [OpenAPI-Spec](https://github.com/swagger-api/swagger-core/wiki) from a remote server, you can easily generate a server stub.  
