/*
 * Workload API
 * Benchmark your distributed DBMS with a specific workload
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package de.uulm.omi.cloudiator.dbms.evaluator.model;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import de.uulm.omi.cloudiator.dbms.evaluator.model.DBEndpoints;
import de.uulm.omi.cloudiator.dbms.evaluator.model.TSBSDataGeneration;
import de.uulm.omi.cloudiator.dbms.evaluator.model.TSBSLoadExecution;
import de.uulm.omi.cloudiator.dbms.evaluator.model.TSBSQueryExecution;
import de.uulm.omi.cloudiator.dbms.evaluator.model.TSBSQueryGeneration;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import javax.validation.constraints.*;

/**
 * TSBSWorkload
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaJerseyServerCodegen", date = "2020-05-19T16:43:06.028+02:00")
public class TSBSWorkload   {
  @JsonProperty("dbEndpoints")
  private DBEndpoints dbEndpoints = null;

  /**
   * specifies the data format for the selected DBMS
   */
  public enum DbmsEnum {
    INFLUX("INFLUX"),
    
    TIMESCALEDB("TIMESCALEDB"),
    
    MONGO("MONGO"),
    
    CASSANDRA("CASSANDRA");

    private String value;

    DbmsEnum(String value) {
      this.value = value;
    }

    @Override
    @JsonValue
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static DbmsEnum fromValue(String text) {
      for (DbmsEnum b : DbmsEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("dbms")
  private DbmsEnum dbms = null;

  @JsonProperty("tsbsDataGeneration")
  private TSBSDataGeneration tsbsDataGeneration = null;

  @JsonProperty("tsbsLoadExecution")
  private TSBSLoadExecution tsbsLoadExecution = null;

  @JsonProperty("tsbsQueryGeneration")
  private TSBSQueryGeneration tsbsQueryGeneration = null;

  @JsonProperty("tsbsQueryExecution")
  private TSBSQueryExecution tsbsQueryExecution = null;

  public TSBSWorkload dbEndpoints(DBEndpoints dbEndpoints) {
    this.dbEndpoints = dbEndpoints;
    return this;
  }

  /**
   * Get dbEndpoints
   * @return dbEndpoints
   **/
  @JsonProperty("dbEndpoints")
  @ApiModelProperty(value = "")
  public DBEndpoints getDbEndpoints() {
    return dbEndpoints;
  }

  public void setDbEndpoints(DBEndpoints dbEndpoints) {
    this.dbEndpoints = dbEndpoints;
  }

  public TSBSWorkload dbms(DbmsEnum dbms) {
    this.dbms = dbms;
    return this;
  }

  /**
   * specifies the data format for the selected DBMS
   * @return dbms
   **/
  @JsonProperty("dbms")
  @ApiModelProperty(value = "specifies the data format for the selected DBMS")
  public DbmsEnum getDbms() {
    return dbms;
  }

  public void setDbms(DbmsEnum dbms) {
    this.dbms = dbms;
  }

  public TSBSWorkload tsbsDataGeneration(TSBSDataGeneration tsbsDataGeneration) {
    this.tsbsDataGeneration = tsbsDataGeneration;
    return this;
  }

  /**
   * Get tsbsDataGeneration
   * @return tsbsDataGeneration
   **/
  @JsonProperty("tsbsDataGeneration")
  @ApiModelProperty(value = "")
  public TSBSDataGeneration getTsbsDataGeneration() {
    return tsbsDataGeneration;
  }

  public void setTsbsDataGeneration(TSBSDataGeneration tsbsDataGeneration) {
    this.tsbsDataGeneration = tsbsDataGeneration;
  }

  public TSBSWorkload tsbsLoadExecution(TSBSLoadExecution tsbsLoadExecution) {
    this.tsbsLoadExecution = tsbsLoadExecution;
    return this;
  }

  /**
   * Get tsbsLoadExecution
   * @return tsbsLoadExecution
   **/
  @JsonProperty("tsbsLoadExecution")
  @ApiModelProperty(value = "")
  public TSBSLoadExecution getTsbsLoadExecution() {
    return tsbsLoadExecution;
  }

  public void setTsbsLoadExecution(TSBSLoadExecution tsbsLoadExecution) {
    this.tsbsLoadExecution = tsbsLoadExecution;
  }

  public TSBSWorkload tsbsQueryGeneration(TSBSQueryGeneration tsbsQueryGeneration) {
    this.tsbsQueryGeneration = tsbsQueryGeneration;
    return this;
  }

  /**
   * Get tsbsQueryGeneration
   * @return tsbsQueryGeneration
   **/
  @JsonProperty("tsbsQueryGeneration")
  @ApiModelProperty(value = "")
  public TSBSQueryGeneration getTsbsQueryGeneration() {
    return tsbsQueryGeneration;
  }

  public void setTsbsQueryGeneration(TSBSQueryGeneration tsbsQueryGeneration) {
    this.tsbsQueryGeneration = tsbsQueryGeneration;
  }

  public TSBSWorkload tsbsQueryExecution(TSBSQueryExecution tsbsQueryExecution) {
    this.tsbsQueryExecution = tsbsQueryExecution;
    return this;
  }

  /**
   * Get tsbsQueryExecution
   * @return tsbsQueryExecution
   **/
  @JsonProperty("tsbsQueryExecution")
  @ApiModelProperty(value = "")
  public TSBSQueryExecution getTsbsQueryExecution() {
    return tsbsQueryExecution;
  }

  public void setTsbsQueryExecution(TSBSQueryExecution tsbsQueryExecution) {
    this.tsbsQueryExecution = tsbsQueryExecution;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TSBSWorkload tsBSWorkload = (TSBSWorkload) o;
    return Objects.equals(this.dbEndpoints, tsBSWorkload.dbEndpoints) &&
        Objects.equals(this.dbms, tsBSWorkload.dbms) &&
        Objects.equals(this.tsbsDataGeneration, tsBSWorkload.tsbsDataGeneration) &&
        Objects.equals(this.tsbsLoadExecution, tsBSWorkload.tsbsLoadExecution) &&
        Objects.equals(this.tsbsQueryGeneration, tsBSWorkload.tsbsQueryGeneration) &&
        Objects.equals(this.tsbsQueryExecution, tsBSWorkload.tsbsQueryExecution);
  }

  @Override
  public int hashCode() {
    return Objects.hash(dbEndpoints, dbms, tsbsDataGeneration, tsbsLoadExecution, tsbsQueryGeneration, tsbsQueryExecution);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TSBSWorkload {\n");
    
    sb.append("    dbEndpoints: ").append(toIndentedString(dbEndpoints)).append("\n");
    sb.append("    dbms: ").append(toIndentedString(dbms)).append("\n");
    sb.append("    tsbsDataGeneration: ").append(toIndentedString(tsbsDataGeneration)).append("\n");
    sb.append("    tsbsLoadExecution: ").append(toIndentedString(tsbsLoadExecution)).append("\n");
    sb.append("    tsbsQueryGeneration: ").append(toIndentedString(tsbsQueryGeneration)).append("\n");
    sb.append("    tsbsQueryExecution: ").append(toIndentedString(tsbsQueryExecution)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

